"BgCorrection.ProSpect" <-
function(dat,smoother="rsmooth",bandwidth=5,subsample=10) {

  if(smoother!="loess" & smoother !="rsmooth") {
    stop(paste("please use for argument 'smoother'",
               "\"loess\" or \"rsmooth\"."))
  }
    
  #------------------------------------#
  # TODO: apply(loess.dat,2,function)  #
  #------------------------------------#

  num.spectra<-ncol(dat$loess.dat)
                          #number of columns (spectra)
                          #counts of values in the 2. dim of ci.dat
  
  loess.dat<-dat$loess.dat
                          #Restrict the original given 3dim Array ci.dat
                          # to the range of interest.
  fit.loess<-list(NULL)
                          #to keep the fit of the loess curve

  #=================================================================
  # The prepared array loess.dat undergoing the loess correction now
  #=================================================================

  if(smoother=="rsmooth") {
    if(subsample !=1){
      subsample=1;
#      warning(paste("For \"smoother=rsmooth\" is only",
#                    "subsample=1 allowed. Program set subsample=1."))
    }
  }
  start <- 1
  end<- nrow(loess.dat)
                          #count of rows of loess.dat
                          #not 'length(loess.dat)' because
                          # -> count of all values (row*column)
  ndx <- seq(start,end,by=subsample)
                          #create a index which is used to choose the
                          # rows for the calculation of the loess
                          # curve.
                          #the using of ndx (instead of all rows)
                          # should help to reduce the datas for the
                          # calculation of the loess curve and to
                          # make the code faster.

  # security check: if the last value of ndx is not equal to end than
  # you get a NA for the last values of loess.dat[,,2]
  # (the intensitiy values).
  # Reason is that predict() cannot predict values of loess.dat[,i,1]
  #  (mz values) which are out of range of tmp
  if (ndx[length(ndx)]!= end) {
                          #to prevent this the last value of the
                          # loess.dat[range,,] must added to the index
                          # (ndx).
    ndx <- c(ndx,end)
  }
  for(i in 1:num.spectra) {


    if(smoother=="rsmooth") {
      library(rsmooth)
      x<-loess.dat[,i,1]
      y<-loess.dat[,i,2]
      tmp <- rsmooth(x,y,bw=bandwidth)    
      fit <- tmp$y    
      loess.dat <- loess.dat[1:length(fit),,]     
#      fit <- approx(tmp$x,tmp$y,xout=loess.dat[,i,1],method="linear",rule=2)
                           # linear interpolate the values in tmp
                           # with the mz values in loess.dat
      loess.dat[,i,2] <- loess.dat[,i,2]-fit
      fit.loess[[i]] <- tmp    
                          #keeping the fitted rsmooth curve     
    }else{
      x<-loess.dat[ndx,i,1]
                          #m/z values for each spectrum within the
                          # range of interest
                          #error: "span is to small" means
                          # no founded mz values in the given range
      y<-loess.dat[ndx,i,2]
                          #intensity values for each spectrum within
                          #  the range of interest
      tmp<-loess(y~x)
                          #tmp contains the loess corrected intensities
                          #(y~x) is the choosen formula which means
                          # y=f(x)
      fit <- predict(tmp,loess.dat[,i,1])
                          #predict() calculate with the values in tmp
                          # the mz values in loess.dat
      loess.dat[,i,2] <- loess.dat[,i,2]-fit
      fit.loess[[i]] <- tmp   
                          #keeping the fitted loess curve
    }
  }
  return(list(loess.dat=loess.dat,
              fit.loess=fit.loess,
              sample=dat$sample,
              expt=dat$expt,
              range=dat$range,
              ndx=ndx))
}

