"ObjFunction" <-
function(step,mzRef,mzOth){
  
  ##=============================================##
  ##This function computed the objective function##
  ## (mzRef[t]-mzOth[t+step])^2                  ##
  ##=============================================##
  
  ##-mzRef is the mz values of the reference spectrum
  ##-mzOth is the mz values of the other spectrum
  ##-step is the number of steps the mzOth must shift

  if(abs(step)>=min(length(mzRef),length(mzRef))){
    return(Inf)
  }else{
  
    if(step%%1!=0){
      step<-list(ceiling(step),floor(step))
    }
  
    ##A function that compute the objective function
    ## given the mz's of both spectra and step
    objective<-function(mzRef,mzOth,step){
      valid<-alignSpec(mzRef,mzOth,step)
      objValue<-sum((mzOth[valid[,"oth"]]-mzRef[valid[,"ref"]])^2)
      return(objValue)
    }
    
    if(!is.list(step)){
      objValue<-objective(mzRef,mzOth,step)
    }else{
      
      objValue<-lapply(step,objective,mzRef=mzRef,mzOth=mzOth)
      stepMin<-which.min(objValue)
      
      objValue<-unlist(objValue[stepMin])
      step<-step[[stepMin]]
    }
    
    return(objValue)
  }  
}

