"alignSpec" <-
function(mzRef,mzOth,step){
  ##==========================================================##
  ##Align the mz when step is used to optimize the arrangement##
  ##==========================================================##
  
  ##-mzRef is the mz values of the reference spectrum
  ##-mzOth is the mz values of the other spectrum
  ##-step is the number of steps the mzOth must shift
  
  if(step>=0){#fix the mzRef (i.e it will start from 1)
    
    ##=========================================##
    ##Find out the valid range for both spectra##
    ##=========================================##

    ##The first entry for both spectra
    firstRef<-1
    firstOth<-1+step

    ##The last entry for both spectra
    lastOth<-length(mzOth)
    lastRef<-lastOth-step
    
  }else{#fix the mzOth (i.e it will start from 1)
    
    ##=========================================##
    ##Find out the valid range for both spectra##
    ##=========================================##

    ##The first entry for both spectra
    firstOth<-1
    firstRef<-1-step
    
    ##The last entry for both spectra
    lengthBoth<-min((length(mzRef)-firstRef+1),length(mzOth))
    lastRef<-firstRef+lengthBoth-1
    lastOth<-lengthBoth
    
  }
  
  ##The valid entry for both spectra  
  validOth<-firstOth:lastOth
  validRef<-firstRef:lastRef

  finalValid<-cbind(validRef,validOth)
  colnames(finalValid)<-c("ref","oth")
  return(finalValid)
}

