"basic.summary.ProSpect" <-
function(ci.dat){
  
  num.spectra<-ncol(ci.dat)
  ##================================##
  ##Summary statistics for Intensity##
  ##================================##
  ##Intensity summary statistics (range,mean, sd) for each spectrum
  intensity.range.each<-apply(ci.dat[,,2],2,"range")
  intensity.mean.each<-apply(ci.dat[,,2],2,"mean")
  intensity.sd.each<-sd(ci.dat[,,2])
  
  ##Intensity summary statistics (range,mean, sd) for all spectrum
  intensity.all<-c(range(ci.dat[,,2]),mean(ci.dat[,,2]),sd(c(ci.dat[,,2])))

  ##Final output for intensity
  intensity.final<-rbind(intensity.all,
                         cbind(t(intensity.range.each),(intensity.mean.each),(intensity.sd.each)))

  if(is.null(colnames(ci.dat))){
    spec.names<-paste(rep("spectra",times=num.spectra),c(,1:num.spectra))
  }else{
    spec.names<-colnames(ci.dat)
  }
  
  dimnames(intensity.final)<-list(c("overall",spec.names),
                                  c("min","max","mean","sd"))
  
  ##==========================##
  ##Summary statistics for M/Z##
  ##==========================##
  ##M/Z summary statistics (range,mean, sd) for each spectrum
  mz.range.each<-apply(ci.dat[,,1],2,"range")
  mz.mean.each<-apply(ci.dat[,,1],2,"mean")
  mz.sd.each<-sd(ci.dat[,,1])
  
  ##M/Z summary statistics (range,mean, sd) for all spectrum
  mz.overall<-c(range(ci.dat[,,1]),mean(ci.dat[,,1]),sd(c(ci.dat[,,1])))

  ##Final output for M/Z
  mz.final<-rbind(mz.overall,
                  cbind(t(mz.range.each),(mz.mean.each),(mz.sd.each)))
  
  dimnames(mz.final)<-list(c("overall",spec.names),
                           c("min","max","mean","sd"))

  ##==================================================##
  ##The number of spectra and the number of TOF points##
  ##==================================================##
  basic.spectra.info<-c(ncol(ci.dat),nrow(ci.dat))
  names(basic.spectra.info)<-c("no. spectrum","no. of TOF points")
  
  return(list(mz=mz.final,intensity=intensity.final,num.points=nrow(ci.dat),
              basic.spectra.info=basic.spectra.info))
  
}

