mix<-function(j,y,p,para){

  ##Purpose: To compute the components of the finite mixture model from (4)
  ##         Sub-routine for EMregion
  ##=Input:
  ##  -j is a scalar indicating which component/mode it is
  ##  -y is a vector of the mz dimension
  ##  -p is a vector of proportions for each component of the mixture model in (4)
  ##  -para is
  ##   a matrix with 1st col shift parameter, 2nd col mean and 3rd col sigma (j<=M);
  ##   the rows correspond to the no. of modes
  ##
  ##=Output:
  ##  -a vector with length corresponding to the length of y and is the p_j*f_j(y) of
  ##   the jth indices.
  
  ##...The shifted log-model component (3)
  ##Specify the parameters to the shifted log-normal
  s<-para[j,1];mu<-para[j,2];sigma<-para[j,3]
  ##One of the component of the M peaks
  out<-p[j]*dlnorm(y-s,mu,sigma)
    
  return(out)
  
}
