"modFcorr.fdr" <-
function (mod.F, name = c("median", "arithmetic", "turkey", "trimmed"), 
    B = 10, t.prop = 0.1, proc = c("BH", "BY")) 
{
    ownFDR = function(p) {
        revcummin = function(x) rev(cummin(rev(x)))
        n = length(p)
        index = order(p)
        psort = p[index]
        retBH = revcummin(pmin(n * psort/(1:n), 1))
        retBY = revcummin(pmin(sum(1/(1:n)) * n * psort/(1:n), 
            1))
        ret = cbind(psort, retBH, retBY)
#######################################################################
##Previous code of above line:
##      ret = cbind(p, retBH, retBY)
##The vector p was the under sorted p but retBH and retBY are based on
## ordered vector p (i.e. psort)
#######################################################################
        ret[order(index), ]
    }
    mz <- mod.F$mz
    if (name != "median") {
        eval(parse(text = paste("mF<-mod.F$", name, "[,1]", sep = "")))
        eval(parse(text = paste("df2<-mod.F$", name, "[,2]", 
            sep = "")))
    }
    else {
        eval(parse(text = paste("mF<-mod.F$", name, sep = "")))
    }
    cMed.mF <- NULL
    cArithmetic.mF <- NULL
    cTukey.mF <- NULL
    cTrimmed.mF <- NULL
    pMed.mF <- NULL
    pArithmetic.mF <- NULL
    pTukey.mF <- NULL
    pTrimmed.mF <- NULL
    med <- NULL
    arithmetic <- NULL
    tukey <- NULL
    trimmed <- NULL
    num.run <- NULL
    ord.mz <- order(mz[, "mean.mz"])
    if (all(ord.mz == rownames(mz))) {
        num.pts <- nrow(mz)
        B1 <- ceiling(B/100 * num.pts)
        for (i in 1:num.pts) {
            if (i != 1 & i != num.pts) {
                leftB1.neighbour <- if (i > B1) 
                  (i - B1)
                else 1
                rightB1.neighbour <- if (i < num.pts - B1) 
                  (i + B1)
                else num.pts
                subset.neighbours <- c(leftB1.neighbour:rightB1.neighbour)
            }
            else {
                if (i == 1) {
                  subset.neighbours <- c(1:B1)
                }
                else {
                  subset.neighbours <- c((num.pts - B1 + 1):num.pts)
                }
            }
            diff.neighboursCurrMz <- abs(mz[subset.neighbours, 
                "mean.mz"] - mz[i, "mean.mz"])
            B1.neighbours <- sort(order(diff.neighboursCurrMz)[1:B1])
            B1.mF <- na.omit(mF[subset.neighbours][B1.neighbours])
            num.run <- c(num.run, length(B1.mF))
            tmp.mean <- tukey.biwt(B1.mF)
            tukey <- c(tukey, tmp.mean$mean)
            ord.B1mF <- order(B1.mF)
            trimmed.points <- ceiling((t.prop * num.run[i])/2)
            if (num.run[i] <= 2 * trimmed.points) 
                stop("The t.mean is too big!!! Reduce it")
            weight <- rep(c(FALSE, TRUE, FALSE), times = c(trimmed.points, 
                (num.run[i] - 2 * trimmed.points), trimmed.points))
            trimmed <- c(trimmed, weighted.mean(B1.mF[ord.B1mF], 
                weight))
            arithmetic <- c(arithmetic, mean(B1.mF))
            med <- c(med, median(B1.mF))
            df1 <- mod.F$df1
            if (name == "median") {
                cTrimmed.mF <- c(cTrimmed.mF, mF[i]/trimmed[i] * 
                  df1)
                pTrimmed.mF <- c(pTrimmed.mF, pchisq(cTrimmed.mF[i], 
                  df1, lower.tail = FALSE))
                cTukey.mF <- c(cTukey.mF, mF[i]/tukey[i] * df1)
                pTukey.mF <- c(pTukey.mF, pchisq(cTukey.mF[i], 
                  df1, lower.tail = FALSE))
                cArithmetic.mF <- c(cArithmetic.mF, mF[i]/arithmetic[i] * 
                  df1)
                pArithmetic.mF <- c(pArithmetic.mF, pchisq(cArithmetic.mF[i], 
                  df1, lower.tail = FALSE))
                cMed.mF <- c(cMed.mF, mF[i]/med[i] * qchisq(0.5, 
                  df1))
                pMed.mF <- c(pMed.mF, pchisq(cMed.mF[i], df1, 
                  lower.tail = FALSE))
            }
            else {
                cTrimmed.mF <- rbind(cTrimmed.mF, c(mF[i] * df1, 
                  mF[i])/trimmed[i])
                pTrimmed.mF <- rbind(pTrimmed.mF, c(pchisq(cTrimmed.mF[i, 
                  1], df1, lower.tail = FALSE), pf(cTrimmed.mF[i, 
                  2], df1, df2[i], lower.tail = FALSE)))
                cTukey.mF <- rbind(cTukey.mF, c(mF[i] * df1, 
                  mF[i])/tukey[i])
                pTukey.mF <- rbind(pTukey.mF, c(pchisq(cTukey.mF[i, 
                  1], df1, lower.tail = FALSE), pf(cTukey.mF[i, 
                  2], df1, df2[i], lower.tail = FALSE)))
                cArithmetic.mF <- rbind(cArithmetic.mF, c(mF[i] * 
                  df1, mF[i])/arithmetic[i])
                pArithmetic.mF <- rbind(pArithmetic.mF, c(pchisq(cArithmetic.mF[i, 
                  1], df1, lower.tail = FALSE), pf(cArithmetic.mF[i, 
                  2], df1, df2[i], lower.tail = FALSE)))
                cMed.mF <- rbind(cMed.mF, c(mF[i] * qchisq(0.5, 
                  df1), mF[i] * qf(0.5, df1, df2[i]), mF[i] * 
                  qf(0.5, df1, df2[i]) * df1)/med[i])
                pMed.mF <- rbind(pMed.mF, c(pchisq(cMed.mF[i, 
                  1], df1, lower.tail = FALSE), pf(cMed.mF[i, 
                  2], df1, df2[i], lower.tail = FALSE), pchisq(cMed.mF[i, 
                  3], df1, lower.tail = FALSE)))
            }
        }
        if (name == "median") {
            fdr.tmp <- ownFDR(pTrimmed.mF)
            cTrimmed.mF <- cbind(cTrimmed.mF, fdr.tmp)
            colnames(cTrimmed.mF) <- c("c.mF", "pValue", "fdr.BH", 
                "fdr.BY")
            fdr.tmp <- ownFDR(pTukey.mF)
            cTukey.mF <- cbind(cTukey.mF, fdr.tmp)
            colnames(cTukey.mF) <- c("c.mF", "pValue", "fdr.BH", 
                "fdr.BY")
            fdr.tmp <- ownFDR(pArithmetic.mF)
            cArithmetic.mF <- cbind(cArithmetic.mF, fdr.tmp)
            colnames(cArithmetic.mF) <- c("c.mF", "pValue", "fdr.BH", 
                "fdr.BY")
            fdr.tmp <- ownFDR(pMed.mF)
            cMed.mF <- cbind(cMed.mF, fdr.tmp)
            colnames(cMed.mF) <- c("c.mF", "pValue", "fdr.BH", 
                "fdr.BY")
        }
        else {
            fdr.tmp <- apply(pTrimmed.mF, 2, ownFDR)
            cTrimmed.mF <- cbind(cTrimmed.mF, fdr.tmp)
            colnames(cTrimmed.mF) <- c("c.mF.c", "c.mF.f", "pValue.c", 
                "fdr.BH.c", "fdr.BY.c", "pValue.f", "fdr.BH.f", 
                "fdr.BY.f")
            fdr.tmp <- apply(pTukey.mF, 2, ownFDR)
            cTukey.mF <- cbind(cTukey.mF, fdr.tmp)
            colnames(cTukey.mF) <- c("c.mF.c", "c.mF.f", "pValue.c", 
                "fdr.BH.c", "fdr.BY.c", "pValue.f", "fdr.BH.f", 
                "fdr.BY.f")
            fdr.tmp <- apply(pArithmetic.mF, 2, ownFDR)
            cArithmetic.mF <- cbind(cArithmetic.mF, fdr.tmp)
            colnames(cArithmetic.mF) <- c("c.mF.c", "c.mF.f", 
                "pValue.c", "fdr.BH.c", "fdr.BY.c", "pValue.f", 
                "fdr.BH.f", "fdr.BY.f")
            fdr.tmp <- apply(pMed.mF, 2, ownFDR)
            cMed.mF <- cbind(cMed.mF, fdr.tmp)
            colnames(cMed.mF) <- c("c.mF.c", "c.mF.f", "c.mF.fc", 
                "pValue.c", "fdr.BH.c", "fdr.BY.c", "pValue.f", 
                "fdr.BH.f", "fdr.BY.f", "pValue.fc", "fdr.BH.fc", 
                "fdr.BY.fc")
        }
        return(list(cArithmetic.mF = cArithmetic.mF, cTrimmed.mF = cTrimmed.mF, 
            cTukey.mF = cTukey.mF, cMed.mF = cMed.mF, scalar.trimmed = trimmed, 
            scalar.tukey = tukey, scalar.arithmetic = arithmetic, 
            scalar.med = med, num.run.Fprime = num.run, num.run.sMse = mod.F$num.run.sMse, 
            B.corr = c(B, B1), B.sMse = mod.F$B.sMse, trimmedProportion.corr = c(t.prop, 
                2 * trimmed.points), trimmedProportion.sMse = mod.F$trimmed.propotion.sMse, 
            df1 = df1, smoothingMean.type = name, df2 = if (name == 
                "median") NULL else df2, mz = mod.F$mz, expt = mod.F$expt, 
            num.points = mod.F$num.points, sample = mod.F$sample, 
            range = mod.F$range))
    }
    else {
        print("the ordering of the mean mz are not increasing!!!")
    }
}

