"windows.merge" <-
function(zoom.mz,alpha){
  
  ##tmp.alpha<-sort(alpha)
  if(any(sort(alpha)!=alpha)){
    stop("the significant window id is not sorted in order!!!")
  }
  
  ##==================================================================##
  ##To know the significant windows that are consecutive and those not##
  ##==================================================================##
  ## The ordering represent the first significant window to the n-1 significant window
  ##  and the entries are the number of windows to its right are also significant.
  total.windows<-length(alpha)
  con.windows.info<-rep(0,times=(total.windows-1))
  
  ##Initializing some parameters
  ##The number of consecutive significant windows to the right
  num.con.windows<-1 
  ##The distance between the ith entry with the ith+num.con.windows
  diff.alpha<-alpha[(1+num.con.windows):total.windows] - alpha[1:(total.windows-num.con.windows)]
  ##The distance between the lagged windows are the same
  window.diff<-(diff.alpha==num.con.windows)
    
  while(any(window.diff)){
    ##To update the number of windows to the right are consecutively significant
    con.windows.info[which(window.diff)]<-num.con.windows
    
    ##update the num.con.windows, diff.alpha and window.diff
    num.con.windows<-num.con.windows+1 
    diff.alpha<-alpha[(1+num.con.windows):total.windows] - alpha[1:(total.windows-num.con.windows)]
    window.diff<-(diff.alpha==num.con.windows)      
  }
  
  ##===================================##
  ##To merge those that are consecutive##
  ##===================================##
  
  windows.location<-1
  mz.mean<-NULL
  mz.range<-NULL
  win.id<-NULL
  id<-alpha
  
  while(windows.location<=total.windows){
    if(windows.location==total.windows){#only for the last window
      if(con.windows.info[(windows.location-1)]==1){#for security clear (it should not happen)
        stop("there is an error")
      }else{
        ##Get the mean of the mean intensity of the window
        mz.mean<-c(mz.mean,zoom.mz[windows.location,1])
        mz.range<-rbind(mz.range,zoom.mz[windows.location,3:4])
        ##Get the row.id of the last window
        win.id<-rbind(win.id,c(id[windows.location],id[windows.location]))
        ##go to the next window
        windows.location<-windows.location+1
      }
    }else{#for all other windows except the last window
      if(con.windows.info[windows.location]==0){#No consecutive windows
        ##Get the mean of the mean intensity of the window
        mz.mean<-c(mz.mean,zoom.mz[windows.location,1])
        mz.range<-rbind(mz.range,zoom.mz[windows.location,3:4])
        ##Get the row.id of the last window
        win.id<-rbind(win.id,c(id[windows.location],id[windows.location]))
        ##go to the next window
        windows.location<-windows.location+1
      }else{#Windows with at least 1 consecutive window
        ##find out the location of consecutive windows
        location.last.con.window<-windows.location+con.windows.info[windows.location]
        consecutive.windows<-windows.location:location.last.con.window
        ##using the mean of mean mz to characterize the consecutive windows
        mz.mean<-c(mz.mean,mean(zoom.mz[consecutive.windows,1]))
        mz.range<-rbind(mz.range,range(zoom.mz[consecutive.windows,3:4]))
        ##Get the row.id of the last window
        win.id<-rbind(win.id,c(id[windows.location],id[location.last.con.window]))
        ##go to the next window
        windows.location<-location.last.con.window+1
      }
    }
  }
  return(list(id=alpha,mz.mean=mz.mean,mz.range=mz.range,win.id=win.id,con.windows.info=con.windows.info))
}

