\name{BgCorrection.ProSpect}
\alias{BgCorrection.ProSpect}
%\alias{}
%\alias{}
%\alias{}
%\alias{}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Peform background correction on the spectra}
\description{
  The mass spectrometry spectra to be analysed undergo a background
  correction to remove any additional baseline noise.
}
\usage{
BgCorrection.ProSpect(dat, smoother = "rsmooth", bandwidth = 5, subsample = 10)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{dat}{First component of the list from the function reduct.ProSpect().}
  \item{smoother}{The smoother which has to be used for the
    normalisation step
    \code{rsmooth}\cr
    \code{loess}}\cr
  \item{bandwidth}{Specifies the bandwith for the smoother \code{rsmooth}}
  \item{subsample}{Specifies how much values have to be used for the
    calculation of normalisation curve by using the smoother
    \code{loess}(100\% values/ subsample )}
}
%\details{
%  
%}
\value{
Returns a list:
 \item{loess.dat}{an array containing the mz and intensity of the
   aligned and restricted spectra after background correction. The rows (1st-dimension)
   corresponding to the no. of TOF points, columns (2nd-dimension)
   corresponding to the spectra and the 3rd-dimension corresponding to
   the mz (1st entry) and intensity (2nd entry) values.}
 \item{fit.loess}{a list containing a vector of the intensities of the
   background noise. The dimension of the list correspond to the number of spectra.}
 \item{sample}{list of characters of the .csv files from which the mz
   and intensity values of the spectra are read in.}
 \item{expt}{a string describing the SELDI experiment.}
 \item{range}{the row indices of read.dat that correspond to the restricted data.}
 \item{ndx}{subset of points of dat used for performing loess on the intensities.}
}
\references{

  Tan CS, Ploner A, Quandt A, Lehtio J, Pawitan Y. 2006. Finding
  regions of significance in SELDI measurements for identifying protein
  biomarkers. \emph{Bioinformatics}, \bold{22(12)}:1515--23.

  Quandt A, Ploner A, Tan CS, Lehtio J, Pawitan Y. 2005. ProSpect: An
  R Package for Analyzing SELDI Measurements Identifying Protein
  Biomarkers. \emph{Lecture Notes in Computer Science}, \bold{3695}:140--150.
  
}
%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\examples{
# R library folder
jj <- .libPaths()[1]

#Path to the example folder
pathToExample <- file.path(jj,"ProSpect","SpikeInData/")

#Read in the .csv files from Ciphergen
read.dat <- read.ProSpect(spectra.dir=pathToExample,expt.name="An example
data")

#Reduce and align the spectra
reduct.dat <- reduct.ProSpect(dat=read.dat[[1]],range.mz=c(5000,6000))

#Peform background correction on the reduced and aligned spectra
loess.dat <- BgCorrection.ProSpect(dat=reduct.dat)

}
\author{Tan Chuen Seng, Andreas Quandt, Alexander Ploner and Yudi Pawitan}
\keyword{ utilities}% at least one, from doc/KEYWORDS

