\name{arrayInfoPA}

\alias{arrayInfoPA}

%\alias{}
%\alias{}
%\alias{}
%\alias{}
%\alias{}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Extract information of peaks from parametric approach}
\description{
  Extract the mz and intensity of the peaks from the parametric approach
  by assuming the peak to be log-normal.
}
\usage{
arrayInfoPA(output)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{output}{Object from the function findPeaks() or quantifyPeaks().}
}
%\details{
%  
%}
\value{
 Returns an array with rows corresponding to peaks, columns
 correpsonding to spectra and the 3rd dimension corresponding to (mz),
 (intensity) and (converge). converge indicate whether the EM-aglorithm
 has converged and NA if not applicable.
}
% \references{

%   Tan CS, Ploner A, Quandt A, Lehtio J, Pernemalm M, Lewensohn R,
%   Pawitan Y. 2006. Annotated regions of significance of SELDI-TOF-MS
%   spectra for detecting protein biomarkers. \emph{Proteomics},
%   \bold{6(23)}:6124--33

%   Dijkstra M, Roelofsen H, Vonk RJ, Jansen RC. 2006. Peak quantification
%   in surface-enhance laser desorption/ionization by using mixture
%   models. \emph{Proteomics}, \bold{6(19)}:6124--33
    
% }
\seealso{\code{\link{findPeaks}}}
\examples{
# R library folder
jj <- .libPaths()[1]

#Path to the example folder
pathToExample <- file.path(jj,"ProSpect","SpikeInData/")

#stores results of calculation in object output
output <- findPeaks(fullFolderName=pathToExample,
region=c(5.5,6),outputName="SpikeInData")

#extract the mz and intensity of the peaks
infoPA<-arrayInfoPA(output)

}
\author{
Tan Chuen Seng, Andreas Quandt, Alexander Ploner and Yudi
Pawitan
}
\keyword{utilities}% at least one, from doc/KEYWORDS

