\name{plotPeaks}
\alias{plotPeaks}
\alias{significant.plot}
\alias{rawBG.plot}
%\alias{}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Different plots of the results from findPeaks() }
\description{
  It is possible to plot the detected significant peak regions and to
  plot with the option of indicating the groupings of the spectra.
}
\usage{
plotPeaks(dat = NULL, plotWhat = NULL, fileName = NULL, region = NULL, winSizePlot = 0.5, grouping = NULL, colour = NULL, device = c("default", "pdf"), ask = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{dat}{R object created by findPeaks() }
  \item{plotWhat}{Type of plot: "raw", "BGcorrected", "rawBG" and "significant" }
  \item{fileName}{Name of the file where the plot will be saved as a .pdf.}
  \item{region}{Numeric vector of length 2 indicating the range of the
    region (in kDa) to plot. This argument needs to be specified if the
    type of plot is not "significant".}
  \item{winSizePlot}{The range in kDa to visual for each page/plot.
    This argument needs to be specified if the type of plot is "significant". }
  \item{grouping}{String containing R commands that classifies the spectra into different
    groups by using clinical data.}
  \item{colour}{Vector to specify the colors of the found groups. }
  \item{device}{Vector which specifies the plotting devices.}
  \item{ask}{Logical. See ?par.}
}
%\details{
%  ~~ If necessary, more details than the __description__  above ~~
%}
\value{
 Returns a plot or plots of the spectra.
}
%\references{ ~put references to the literature/web site here ~ }
\author{Andreas Quandt*, Chuen Seng Tan*, Alexander Ploner and Yudi
  Pawitan\cr
*Authors contributed equally to this work}
\section{Maintainer}{Chuen Seng Tan <chuenseng.tan@ki.se>}


%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\examples{
# R library folder
jj <- .libPaths()[1]

#Path to the example folder
pathToExample <- file.path(jj,"ProSpect","SpikeInData/")

#stores the results of the calculation in a R object called output
output <- findPeaks(fullFolderName=pathToExample,
region=c(5.5,6),outputName="SpikeInData")

#plot significant peaks
plotPeaks(dat=output,plotWhat="significant",
          fileName="SpikeInData",colour=FALSE,winSizePlot=.5)

#plot significant peaks with the spectra classified into groups
plotPeaks(output,"significant","SpikeInData",grouping="paste(Age<=40,Sex)")
plotPeaks(output,"significant","SpikeInData",grouping='Age>20 & Age<=40') 
plotPeaks(output,"significant","SpikeInData",grouping='paste(Age,Smoker)')
plotPeaks(output,"significant","SpikeInData",grouping='paste(Age==20,Smoker="+")')
#plotPeaks(output,"significant","SpikeInData",grouping='Smoker%in%c("-")',colour=c("blue","green"))

}
\keyword{ utilities}% at least one, from doc/KEYWORDS
