\name{read.ProSpect}

\alias{read.ProSpect}
%\alias{}
%\alias{}
%\alias{}
%\alias{}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Read in the mass spectrometry spectra from SELDI and its clinical
data}
\description{
  To read in the mass spectrometry spectra to be analysed that are the
  .csv files from Ciphergen's software and the clinical information if
  available.
}
\usage{
read.ProSpect(spectra.dir, expt.name = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{spectra.dir}{Path to the folder which contains the .csv
    files of the mass spectra}
  \item{expt.name}{String describing the mass spectrometry experiment}
  
}
\details{
If clinical data is provided, it must be of the following table
format. The rows correspond to the spectra and the first column is the
filename of the spectra. The extension of the clinical data MUST be
.clinDat. See read.delim for more information of the format of the
clinical data.  
}
\value{
 Returns a list:
 \item{ci.dat}{An array containing the mz and intensity of the
   spectra. The rows (1st-dimension) corresponding to the no. of TOF
   points, columns (2nd-dimension) corresponding to the spectra and the
   3rd-dimension corresponding to the mz (1st entry) and intensity (2nd
   entry) values. The attributes sample and project, contain the
   filenames of the spectra and the description of the spectra.}
 \item{clin.dat}{If specified, a matrix containing clinical
   information. The rows should correspond with the spectra. Otherwise,
   it will be logical, FALSE.}
}
% \references{

%   Tan CS, Ploner A, Quandt A, Lehti\"o J, Pawitan Y. 2006. Finding
%   regions of significance in SELDI measurements for identifying protein
%   biomarkers. \emph{Bioinformatics}, 22(12):1515--23.
  
%   Tan CS, Ploner A, Quandt A, Lehti\"o J, Pernemalm M, Lewensohn R,
%   Pawitan Y. 2006. Annotated regions of significance of SELDI-TOF-MS
%   spectra for detecting protein biomarkers. \emph{Proteomics},
%   6(23):6124--33
  
%   Quandt A, Ploner A, Tan CS, Lehti\"o J, Pawitan Y. 2005. ProSpect: An
%   R Package for Analyzing SELDI Measurements Identifying Protein
%   Biomarkers. \emph{Lecture Notes in Computer Science}, 3695:140--150.
  
% }
\seealso{\code{\link{findPeaks}}}
\examples{
# R library folder
jj <- .libPaths()[1]

#Path to the example folder
pathToExample <- file.path(jj,"ProSpect","SpikeInData/")

#Read in the .csv files from Ciphergen
read.dat <- read.ProSpect(spectra.dir=pathToExample,expt.name="An example data")
}
\author{
Tan Chuen Seng, Andreas Quandt, Alexander Ploner and Yudi
Pawitan
}
\keyword{ utilities}% at least one, from doc/KEYWORDS

