\name{reduct.ProSpect}

\alias{reduct.ProSpect}
\alias{alignOptim}
\alias{ObjFunction}

%\alias{}
%\alias{}
%\alias{}
%\alias{}
%\alias{}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Reduce the data to the mz range of interest}
\description{
  To reduce the spectra to mz range of interest.
}
\usage{
reduct.ProSpect(dat, range.mz, method = "grid", grid = 10, 
    plot.indicator = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{dat}{First component of the list from the function read.ProSpect().}
  \item{range.mz}{Vector indicating the mz region of interest in Da.}
  \item{method}{String and only "grid" is used. The alignment of the spectra
    is done via a grid search with a specified number of grid search.}
  \item{grid}{Numeric scalar specifying the number of grid search.}
  \item{plot.indicator}{Logical. To plot diagnostic plots of the grid
    search.}
    
}
%\details{
%}
\value{
 Returns a list:
 \item{loess.dat}{An array containing the mz and intensity of the
   aligned and restricted spectra. The rows (1st-dimension)
   corresponding to the no. of TOF points, columns (2nd-dimension)
   corresponding to the spectra and the 3rd-dimension corresponding to
   the mz (1st entry) and intensity (2nd entry) values.}
 \item{sample}{list of characters of the .csv files from which the mz
   and intensity values of the spectra are read in.}
 \item{expt}{a string describing the SELDI experiment.}
 \item{range}{the row indices of dat that correspond to the restricted data.}
}
\references{

  Tan CS, Ploner A, Quandt A, Lehtio J, Pawitan Y. 2006. Finding
  regions of significance in SELDI measurements for identifying protein
  biomarkers. \emph{Bioinformatics}, \bold{22(12)}:1515--23.

  Quandt A, Ploner A, Tan CS, Lehtio J, Pawitan Y. 2005. ProSpect: An
  R Package for Analyzing SELDI Measurements Identifying Protein
  Biomarkers. \emph{Lecture Notes in Computer Science}, \bold{3695}:140--150.
  
}
%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\examples{
# R library folder
jj <- .libPaths()[1]

#Path to the example folder
pathToExample <- file.path(jj,"ProSpect","SpikeInData/")

#Read in the .csv files from Ciphergen
read.dat <- read.ProSpect(spectra.dir=pathToExample,expt.name="An example
data")

#Reduce and align the spectra
reduct.dat <- reduct.ProSpect(dat=read.dat[[1]],range.mz=c(5000,6000))
}
\author{
Tan Chuen Seng, Andreas Quandt, Alexander Ploner and Yudi
Pawitan
}
\keyword{ utilities}% at least one, from doc/KEYWORDS

