\name{summaryPeaks}
\alias{summaryPeaks}
\alias{basic.summary.ProSpect}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Reports a set of summaries on the spectra analyzed by findPeaks()}
\description{
  The function calculates the basic statistics like mean, median or sd for the mz values and intensities of the
  given spectra. 
}
\usage{
summaryPeaks(object = NULL, data = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{R object created by \code{findPeaks()}}
  \item{data}{ Type of data\cr
    'read' = raw spectra without any modificantion\cr
    'raw' = raw spectra but reduced to the region of interest\cr
    'BGcorrected' = spectra with background correction
  }
}
%\details{
%  ~~ If necessary, more details than the __description__  above ~~
%}
\value{
  A list containing summarized information of the spectra:
  \item{mz}{A matrix with entries corresponding to the
    minimum (min), maximum (max), mean and standard deviation (sd)
    of the mzs of each spectra. The rows correspond to the spectra while
    the columns correspond to min, max, mean and sd.}
  \item{intensity}{Same as above but w.r.t. to the intensities of each spectra.}
  \item{num.points}{The number of paired observations, i.e. (mz,
    intensity), for the spectra.}
  \item{basic.spectra.info}{A vector containing information on the
    number of spectra in the data and the number of TOF points in the spectra.}
}
%\references{ ~put references to the literature/web site here ~ }


%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\author{Andreas Quandt*, Chuen Seng Tan*, Alexander Ploner and Yudi
  Pawitan\cr
*Authors contributed equally to this work}
\section{Maintainer}{Chuen Seng Tan <chuenseng.tan@ki.se>}


%\seealso{ ~~objects to See Also as \code{\link{~~fun~~}}, ~~~ }
\examples{
# R library folder
jj <- .libPaths()[1]

#Path to the example folder
pathToExample <- file.path(jj,"ProSpect","SpikeInData/")

#stores results of calculation in object output
output <- findPeaks(fullFolderName=pathToExample,
region=c(5.5,6),outputName="SpikeInData")

#statistical summary to imported data
summaryPeaks(object=output,data="read")
}
\author{
Tan Chuen Seng, Andreas Quandt, Alexander Ploner and Yudi
Pawitan
}
\keyword{ utilities}% at least one, from doc/KEYWORDS
